# sb::Data::Link
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Data::Link;
use strict;
use sb::Data::Object ();
use base qw( sb::Data::Object );
use vars qw( $VERSION );
$VERSION = '0.04';
# 0.04 [2007/08/04] added initializer
# 0.03 [2006/07/01] ported from biscuit
# 0.02 [2005/07/22] changed data structure to array
# 0.01 [2005/06/30] removed default target attribute
# 0.00 [2005/02/02] generated
# --------------------------------------
# // defines / static variables
sub GROUP_LABEL (){ 'group' };
# --------------------------------------
# // override base class - table
sub table
{
	my $self = shift;
	return (
		'id'     => 'uni_id',   # id
		'wid'    => 'id',       # weblog id (reserved)
		'name'   => 'str(255)', # site name
		'url'    => 'str(255)', # site address
		'text'   => 'text',     # description
		'user'   => 'id',       # editor
		'order'  => 'int',      # order of list
		'disp'   => 'int',      # display status
		'type'   => 'str(255)', # link type
		'target' => 'str(255)', # link target attribute
	);
}
# --------------------------------------
# // initializer
BEGIN
{
	__PACKAGE__->init_accessor();
}
sub default
{ # default settings
	my $self  = shift;
	my %param = @_;
	$param{'wid'} |= 0;
	$param{'user'} |= 0;
	$param{'disp'} |= 0;
	$param{'order'} = $self->id;
	$self->SUPER::initialize(%param);
}
# --------------------------------------
# // public functions
sub is_group
{
	my $self = shift;
	return ($self->type eq GROUP_LABEL);
}
sub set_as_group
{
	my $self = shift;
	$self->type(GROUP_LABEL);
}
# --------------------------------------
# // private functions
1;
__END__
