# sb::Data::Session
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Data::Session;
use strict;
use sb::Data::Object ();
use base qw( sb::Data::Object );
use vars qw( $VERSION );
$VERSION = '0.09';
# 0.09 [2007/09/09] added default
# 0.08 [2007/08/04] added initializer
# 0.07 [2007/07/20] fixed a bug in check_expire
# 0.06 [2007/07/16] changed return to make them consistent
# 0.05 [2006/07/04] got rid of "return( undef )"
# 0.04 [2006/03/17] changed bracket rule
# 0.03 [2006/02/26] replaced elements to table
# 0.02 [2005/10/21] changed data structre
# 0.01 [2005/04/18] added check_expire
# 0.00 [2005/03/15] generated
# --------------------------------------
# // defines / static variables
# ... nothing ...
# --------------------------------------
# // override base class - table
sub table
{
	my $self = shift;
	return (
		'id'   => 'uni_id',   # id
		'key'  => 'str(255)', # key for session
		'data' => 'str(255)', # session date
	);
}
# --------------------------------------
# // initializer
BEGIN
{
	__PACKAGE__->init_accessor();
}
sub default
{ # default settings
	my $self  = shift;
	my %param = @_;
	$self->SUPER::initialize(%param);
}
# --------------------------------------
# // public functions
sub check_expire
{
	my $self = shift;
	my %param = (
		'now'      => undef,
		'duration' => undef,
		@_
	);
	return if (!$param{'now'} or !$param{'duration'});
	my $diff_time = $param{'now'} - ( split('_',$self->data) )[0];
	return ($diff_time <= $param{'duration'});
}
1;
__END__
