// spica javascript libraries - ajax.js
// == written by Takuya Otani <takuya.otani@gmail.com> ===
// == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

Spica.Ajax = function()
{
	this.req = null;
	this.type = 'xml'; // xml or text
	this.method = 'GET'; // GET or POST
	this.async = true;
	return this;
}
Spica.Ajax.createXmlHttp = function()
{
	var object = null;
	try
	{
		if (window.XMLHttpRequest) object = new XMLHttpRequest();
	}
	catch(e) {}
	if (object) return object;
	try
	{
		object = new ActiveXObject("Msxml2.XMLHTTP");
	}
	catch(e) {
		try
		{
			object = new ActiveXObject("Microsoft.XMLHTTP");
		}
		catch(e) {}
	}
	return object;
}
Spica.Ajax.parseXml = function(xmlText)
{
	if (window.ActiveXObject)
	{
		var xmlDom = new ActiveXObject('Microsoft.XMLDOM');
		xmlDom.async = false;
		xmlDom.loadXML(xmlText);
		return xmlDom;
	}
	else if (window.DOMParser)
	{
		var parser = new DOMParser();
		return parser.parseFromString(xmlText, "application/xml");
	}
	return null;
}
Spica.Ajax.prototype = {
	onerror : function(status)
	{ // default error handler - should be overridden
		alert('error : ' + status);
	},
	callback : function(res)
	{ // default handler - should be overridden
		alert('loaded : ' + res.toString());
	},
	post : function(url,data)
	{
		this.method = 'POST';
		this.request(url,data);
	},
	get : function(url,data)
	{
		this.method = 'GET';
		this.request(url,data);
	},
	request : function(url,data)
	{
		var req = this.req = Spica.Ajax.createXmlHttp();
		var self = this;
		this.req.onreadystatechange = function()
		{
			if (req.readyState == 4)
			{
				var stat = req.status;
				if (stat == undefined) stat = 0;
				switch (stat)
				{
				case 0: // for local debugging
				case 200:
					var response = null;
					if (self.type == 'text')
					{ // text
						response = req.responseText;
						if (Spica.Browser.isKHTML)
						{
							var esc = escape(response);
							if (esc.indexOf("%u") < 0 && esc.indexOf("%") > -1)
								response = decodeURIComponent(esc);
						}
					}
					else if (!req.responseXML)
					{ // xml
						response = Spica.Ajax.parseXml(req.responseText);
					}
					else
					{
						response = req.responseXML;
					}
					self.callback(response);
					break;
				case 304:
					self.callback();
					req.onreadystatechange = null;
					break;
				default:
					self.onerror(req.status);
				}
			} // end of if (req.readyState == 4)
		} // end of this.req.onreadystatechange
		this.req.open(this.method,url,this.async);
		if (this.method == "POST")
		{
			try
			{
				this.req.setRequestHeader("Content-Type","application/x-www-form-urlencoded;");
			}
			catch(e) {}
		}
		if (this.type == 'xml')
		{
			try
			{
				this.req.overrideMimeType("text/xml");
			}
			catch(e) {}
		}
		this.req.send(data);
	}
};
